<?php

/*
 * Copyright (C) 2015 IRSTEA
 * All rights reserved.
 */

namespace Irstea\FileUploadBundle\Form\Type;

use Irstea\FileUploadBundle\Service\FileManagerInterface;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Routing\Router;

class FileUploadType extends AbstractType
{
    use \Irstea\ThemeBundle\Form\AbstractJQueryWidgetTrait;

    /**
     *
     * @var Router
     */
    private $router;

    /**
     *
     * @var FileManagerInterface
     */
    private $fileManager;

    public function __construct(Router $router, FileManagerInterface $fileManager)
    {
        $this->router = $router;
        $this->fileManager = $fileManager;
    }

    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        $this->buildWidgetView($view, $form, $options);

        $view->vars['widget_attr']['data-create-url'] = $this->router->generate('file_upload_create');
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $this->setWidgetDefaultOptions($resolver);

        $resolver->setDefaults(
            [
                'data_class' => '\Irstea\FileUploadBundle\Entity\UploadedFile',
                'multiple'   => false,
            ]
        );
    }

    protected function getWidgetDefaults()
    {
        return [];
    }

    public function getName()
    {
        return "file_upload";
    }

    protected function getWidgetType()
    {
        return "irsteaFileUpload";
    }
}
